<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
    <!-- Generated by javadoc -->
    <title>TempFileCreationStrategy (POI API Documentation)</title>
    <link rel="stylesheet" type="text/css" href="../../../../stylesheet.css" title="Style">
    <script type="text/javascript" src="../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="TempFileCreationStrategy (POI API Documentation)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":6,"i1":6};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],4:["t3","Abstract Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";

</script>
<noscript>
    <div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.top.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/TempFileCreationStrategy.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../../index-all.html">Index</a></li>
        <li><a href="../../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li><a href="../../../../org/apache/poi/util/TempFile.html" title="class in org.apache.poi.util"><span
                class="typeNameLink">Prev&nbsp;Class</span></a></li>
        <li><a href="../../../../org/apache/poi/util/Units.html" title="class in org.apache.poi.util"><span
                class="typeNameLink">Next&nbsp;Class</span></a></li>
    </ul>
    <ul class="navList">
        <li><a href="../../../../index.html?org/apache/poi/util/TempFileCreationStrategy.html" target="_top">Frames</a>
        </li>
        <li><a href="TempFileCreationStrategy.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_top">
        <li><a href="../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li>Nested&nbsp;|&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li>Constr&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li>Constr&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.top">
        <!--   -->
    </a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
    <div class="subTitle">org.apache.poi.util</div>
    <h2 title="Interface TempFileCreationStrategy" class="title">Interface TempFileCreationStrategy</h2>
</div>
<div class="contentContainer">
    <div class="description">
        <ul class="blockList">
            <li class="blockList">
                <dl>
                    <dt>All Known Implementing Classes:</dt>
                    <dd><a href="../../../../org/apache/poi/util/DefaultTempFileCreationStrategy.html"
                           title="class in org.apache.poi.util">DefaultTempFileCreationStrategy</a></dd>
                </dl>
                <hr>
                <br>
                <pre>public interface <span class="typeNameLabel">TempFileCreationStrategy</span></pre>
                <div class="block">Interface used by the <a href="../../../../org/apache/poi/util/TempFile.html"
                                                            title="class in org.apache.poi.util"><code>TempFile</code></a>
                    utility class to create temporary files.

                    Classes that implement a TempFileCreationStrategy attempt to handle the cleanup
                    of temporary files.

                    Examples include:
                    <ul>
                        <li><a href="../../../../org/apache/poi/util/DefaultTempFileCreationStrategy.html"
                               title="class in org.apache.poi.util"><code>DefaultTempFileCreationStrategy</code></a>
                            deletes temporary files when
                            the JVM exits.
                            This may not be suitable for long-running applications that never
                            shut down the JVM since the list of registered files and disk space
                            usage would grow for as long as the JVM is running.
                            You may wish to implement your own strategy that meets the needs of
                            your situation.
                        </li>
                        <li>A strategy that keeps the <code>n</code> most-recent files, discarding
                            older files on a first-in, first-out basis.
                            A java.util.Deque or org.apache.commons.collections4.queue.CircularFifoQueue
                            may be helpful for achieving this.
                        </li>
                        <li>A strategy that keeps track of every temporary file that has been
                            created by the class or instance and provides a method to explicitly
                            delete the temporary files in the reverse order that they were created.
                            This is the same as DefaultTempFileCreationStrategy, except the strategy
                            class would maintain the list of files to delete rather than or in
                            addition to <code>DeleteOnExitHook</code> maintaining the list, and
                            the files could be deleted before the JVM exit.
                        </li>
                        <li>A strategy that creates a directory that is deleted on JVM exit.
                            Any files inside the directory do not need to be registered since the
                            entire directory will be deleted at exit.
                            This could be dangerous if files were added to the temporary directory
                            outside of this TempFileCreationStrategy's control.
                            This could be accomplished with <a
                                    href="../../../../org/apache/poi/util/TempFileCreationStrategy.html#createTempDirectory-java.lang.String-"><code>createTempDirectory(String)</code></a>
                            and
                            creating regular (unregistered) files in the temp directory.
                        </li>
                    </ul>
                </div>
            </li>
        </ul>
    </div>
    <div class="summary">
        <ul class="blockList">
            <li class="blockList">
                <!-- ========== METHOD SUMMARY =========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.summary">
                        <!--   -->
                    </a>
                        <h3>Method Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Method Summary table, listing methods, and an explanation">
                            <caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span
                                    id="t2" class="tableTab"><span><a
                                    href="javascript:show(2);">Instance Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span><span id="t3" class="tableTab"><span><a
                                    href="javascript:show(4);">Abstract Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span></caption>
                            <tr>
                                <th class="colFirst" scope="col">Modifier and Type</th>
                                <th class="colLast" scope="col">Method and Description</th>
                            </tr>
                            <tr id="i0" class="altColor">
                                <td class="colFirst"><code>java.io.File</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../org/apache/poi/util/TempFileCreationStrategy.html#createTempDirectory-java.lang.String-">createTempDirectory</a></span>(java.lang.String&nbsp;prefix)</code>
                                    <div class="block">Creates a new and empty temporary directory.</div>
                                </td>
                            </tr>
                            <tr id="i1" class="rowColor">
                                <td class="colFirst"><code>java.io.File</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../org/apache/poi/util/TempFileCreationStrategy.html#createTempFile-java.lang.String-java.lang.String-">createTempFile</a></span>(java.lang.String&nbsp;prefix,
                                    java.lang.String&nbsp;suffix)</code>
                                    <div class="block">Creates a new and empty temporary file.</div>
                                </td>
                            </tr>
                        </table>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
    <div class="details">
        <ul class="blockList">
            <li class="blockList">
                <!-- ============ METHOD DETAIL ========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.detail">
                        <!--   -->
                    </a>
                        <h3>Method Detail</h3>
                        <a name="createTempFile-java.lang.String-java.lang.String-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>createTempFile</h4>
                                <pre>java.io.File&nbsp;createTempFile(java.lang.String&nbsp;prefix,
                            java.lang.String&nbsp;suffix)
                     throws java.io.IOException</pre>
                                <div class="block">Creates a new and empty temporary file.</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>prefix</code> - The prefix to be used to generate the name of the
                                        temporary file.
                                    </dd>
                                    <dd><code>suffix</code> - The suffix to be used to generate the name of the
                                        temporary file.
                                    </dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>The path to the newly created and empty temporary file.</dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code> - If no temporary file could be created.</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="createTempDirectory-java.lang.String-">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>createTempDirectory</h4>
                                <pre>java.io.File&nbsp;createTempDirectory(java.lang.String&nbsp;prefix)
                          throws java.io.IOException</pre>
                                <div class="block">Creates a new and empty temporary directory.</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>prefix</code> - The directory name to be used to generate the name of the
                                        temporary directory.
                                    </dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>The path to the newly created and empty temporary directory.</dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code> - If no temporary directory could be created.
                                    </dd>
                                    <dt><span class="simpleTagLabel">Since:</span></dt>
                                    <dd>POI 3.15 beta 3.</dd>
                                </dl>
                            </li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.bottom.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/TempFileCreationStrategy.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../../index-all.html">Index</a></li>
        <li><a href="../../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li><a href="../../../../org/apache/poi/util/TempFile.html" title="class in org.apache.poi.util"><span
                class="typeNameLink">Prev&nbsp;Class</span></a></li>
        <li><a href="../../../../org/apache/poi/util/Units.html" title="class in org.apache.poi.util"><span
                class="typeNameLink">Next&nbsp;Class</span></a></li>
    </ul>
    <ul class="navList">
        <li><a href="../../../../index.html?org/apache/poi/util/TempFileCreationStrategy.html" target="_top">Frames</a>
        </li>
        <li><a href="TempFileCreationStrategy.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_bottom">
        <li><a href="../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li>Nested&nbsp;|&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li>Constr&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li>Constr&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.bottom">
        <!--   -->
    </a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy">
    <small>
        <i>Copyright 2018 The Apache Software Foundation or
            its licensors, as applicable.</i>
    </small>
</p>
</body>
</html>
